/*ASCII WARS*/

/*by Sean Hatfield */

/* ASCII WARS is both my first attempt at C programming, */
/* and my first attempt at Gameboy programming. */
/* I am using simple ASCII charactors for graphics so I can focus  */
/* on learning C.  As I learn more about C and the Gameboy I may */
/* incorporate that knowledge into future versions. */
/* If you have comments or suggestions I can be reached by email */
/* at seanhat@earthlink.net . */
/* NOTE: This game is based on a concept from an old */
/* Commodore Basic programming book, so credit where credit */
/* is due. */

#include <gb.h>

void cls()                      /*  Clear the Screen */
{
  int x,y;
  for(y=0; y != 18; y++)
  {
    for(x=0;x != 20; x++)
    {
      gotoxy(x,y);
      puts(" ");
    }
  }
}
    

void slowdown()              /* slow down the app */
  {
    int delay, key;
    delay = 500;
    while(delay != 0)
    {
      delay--;
      key = joypad();
      if(key & J_START)
        delay = 0;
      if(key & J_START)
        delay = 0;
      if(key & J_START)
        delay = 0;
    }
  }

void slowmore()
  {
  int county2;
    county2 = 10;
    while(county2 > 0)
    {
    slowdown();
    county2--;
    }
  }

void intro()                      /* intro screen  */
  {
 
  int county, key;
  int county2;
    gotoxy(0, 17);
    puts("   Sean  Hatfield");
    county = 5;
    while(county > 0)
      {
      slowmore(0);
   
      gotoxy(0, 17);
      printf("                     ");
      county--;
      }
  gotoxy(0, 16);
    puts("      Presents");
    county = 20;
    while(county > 0)
      {
      slowmore(0);
      gotoxy(0, 17);
      printf("                     ");
      slowdown();
      county--;
      }
  
  gotoxy(0, 17);
  printf("  AA   SS   CC  I I\n");
  slowmore(0);
  printf(" A  A S  S C  C I I\n");
  slowmore(0);
  printf(" A  A S    C    I I\n");
  slowmore(0);
  printf(" AAAA  SS  C    I I\n");
  slowmore(0); 
  printf(" A  A    S C    I I\n");
  slowmore(0);
  printf(" A  A S  S C  C I I\n");
  slowmore(0);
  printf(" A  A  SS   CC  I I\n");
  slowmore(0);
  printf("\n ");
  slowmore(0);
  printf("\n ");
  slowmore(0);
  printf("\n ");
  slowmore(0);
  gotoxy(0, 17);
  printf("W   W  AA  RRR   SS\n");
  slowmore(0);
  printf("W   W A  A R  R S  S");
  slowmore(0);
  printf("W   W A  A R  R S\n");
  slowmore(0);
  printf("W W W AAAA RRR   SS\n");
  slowmore(0);
  printf("W W W A  A RR      S");
  slowmore(0);
  printf(" W W  A  A R R  S  S");
  slowmore(0);
  printf(" W W  A  A R  R  SS\n");
  while(!0)
    {
    key = joypad();
    gotoxy(0, 8);
    if(key & J_START)
    {
    gotoxy(0, 8);
    puts("                    ");
    return;
    }
    puts("    Press  Start");
    slowmore();
    gotoxy(0, 8);
    puts("                    ");
    if(key & J_START)
    {
    gotoxy(0, 8);
    puts("                    ");
    return;
    }
    slowmore();
    
   }
  
  }

/****************************SOUND EFFECT: GUN SHOOTS ******************/
void gunshoots()    /******* Control Sound 1 ***********/
{
  int sweeptime;
  int sweepmode;
  int sweepshifts;
  int patternduty;
  int soundlength;
  int envinit;
  int envmode;
  int envsteps;
  unsigned int freql;
  int freqh;
  int consecutive;
  int initialflag;
  
  sweeptime = 2; /* 0-7 */
  sweepmode = 1; /* 0-1 */
  sweepshifts = 7; /* 0 - 7 */
  patternduty = 0; /* 0-3 */
  soundlength = 0; /* 0 - 63 */
  envinit = 15; /* 0 - 15 */
  envmode = 0; /* 0-1 */
  envsteps = 2; /* 0 - 7 */
  freql = 165;
  freqh = 6;
  consecutive = 0;
  initialflag = 1;

  NR51_REG = 255; /* send sound to left and rignt */
  NR52_REG = 128;  /* make sure sound is enabled */
  
  NR10_REG = (sweepshifts + (sweepmode * 8) + (sweeptime * 16));
  NR11_REG = (soundlength + (patternduty * 32));
  NR12_REG = (envsteps + (envmode * 8) + (envinit * 16));
  NR13_REG = freql;
  NR14_REG = (freqh + (consecutive * 64) + (initialflag * 128));
  
}  
/*********************SOUND EFFECT: GUN EXPLODES*********/
void gunexplodes()
{
  int length;
  int envinit;
  int envmode;
  int envsteps;
  int polyfreq;
  int polystep;
  int polydiv;
  int consecutive;
  int initialflag;
  int so1;
  int so2;
  
  length = 63; /* 0 - 63 */
  envinit = 15; /* 0 - 15 */
  envsteps = 5; /* 0 - 7 */
  envmode = 0; /* 0 = decrease 1 =  increase */
  polyfreq = 5; /* 0 - 7 */
  polystep = 0; /* 0 - 1 */
  polydiv = 5; /* 0 - 7 */
  consecutive = 0; /* 0 - 1 */
  initialflag = 1; /* 0 - 1 */
  
  
  NR51_REG = 255; /* send sound to left and rignt */
  NR52_REG = (128);  /* make sure sound is enabled */
  NR41_REG = length;
  NR42_REG = (envsteps + (envmode * 8) + (envinit * 16));
  NR43_REG = (polydiv + (polystep * 8) + (polyfreq * 16));
  NR44_REG = (consecutive * 64) + 128;
}

/*********************SOUND EFFECT: UFO EXPLODES*********/
void ufoxplodes()
{
  int length;
  int envinit;
  int envmode;
  int envsteps;
  int polyfreq;
  int polystep;
  int polydiv;
  int consecutive;
  int initialflag;
  int so1;
  int so2;
  
  length = 63; /* 0 - 63 */
  envinit = 15; /* 0 - 15 */
  envsteps = 3; /* 0 - 7 */
  envmode = 0; /* 0 = decrease 1 =  increase */
  polyfreq = 3; /* 0 - 7 */
  polystep = 0; /* 0 - 1 */
  polydiv = 3; /* 0 - 7 */
  consecutive = 0; /* 0 - 1 */
  initialflag = 1; /* 0 - 1 */
  
  
  NR51_REG = 255; /* send sound to left and rignt */
  NR52_REG = (128);  /* make sure sound is enabled */
  NR41_REG = length;
  NR42_REG = (envsteps + (envmode * 8) + (envinit * 16));
  NR43_REG = (polydiv + (polystep * 8) + (polyfreq * 16));
  NR44_REG = (consecutive * 64) + 128;
}

/******************************GAME OVER*******************/
void gameover()
{
  int key;
  while(!0)
  {
    key = joypad();
    gotoxy(0, 8);
    if(key & J_START)
    {
      gotoxy(0, 8);
      puts("                    ");
      cls(0);
      return;
    }
    puts("     GAME  OVER");
    slowmore();
    gotoxy(0, 8);
    puts("                    ");
    if(key & J_START)
    {
    gotoxy(0, 8);
    puts("                    ");
    cls(0);
    return;
    }
    slowmore();
  }
}
  
  
/***************************  MAIN ***************************************/
void main()                     /* main program */
{
  int rndseed;      /* an attempt at random numbers */
  int key, delay, fastloop, gunx, guny;
  int shot1, shot1x, shot1y;
  int bomb1, bomb1x, bomb1y;
  int lives;
  unsigned int score;
  int ufo1, ufo1x, ufo1y, ufo1d;
  int gunstatus, guncount;
  int fireenable;
    
  RESTART:
  
  intro(0);
  
  
  
  /*     INITIALIZE VARIABLES     */
  score = 0;
  rndseed = 0;
  shot1 = 0;
  bomb1 = 0;
  gunx = 8;
  guny = 16;
  lives = 3;
  gunstatus = 1;
  guncount = 0;
  fireenable = 1;
  
  /*    INITIALIZE SCREEN    */
  cls(0);
  gotoxy(gunx, guny);
  printf("=^=");
  
  
/*****************************   MAIN LOOP   ***********************/    
   while(!0)                      /* infinate loop */
   {
     rndseed++;    /* increment on each interation */
     slowdown(0); 
     gotoxy(0,0);
     printf("Score: %u", score);
     gotoxy(11,0);
     printf("Lives: %d", lives);
    
    
     /* Fast Portion */
     fastloop = 0;                                        /* begin fast loop */
    
/******************* MISSILE / BOMB CONTROL *******************/
     while(fastloop < 2)                                /* increase number to speed up */
     { 
       if(shot1)                                        /* begin shot 1 */
       {
        rndseed++;          /* rndseed also increments here */
        gotoxy(shot1x, shot1y);
        if(shot1y > 0)
          printf("|");
        if(shot1y < guny - 1)
        {
          gotoxy(shot1x, shot1y+1);
          printf(" ");
        }
        if((shot1y == ufo1y) && (ufo1))   /*  Collision Detection */
        {
          if((shot1x >= ufo1x) && (shot1x < ufo1x + 3))
          {
            score = score + 1;
            ufoxplodes(0);
            
            if(!(score % 30))
              lives++;
            shot1 = 0;
            ufo1 =0;
            gotoxy(ufo1x, ufo1y);
            puts("   ");
          }
        }
        shot1y = shot1y - 1;
        if(shot1y < 0)
        {
          shot1 = 0;
          gotoxy(shot1x, 1);
          printf(" ");
        }
      }                                                          /*  End of shot1  */
      if(bomb1)                          /******** Begin Bomb Drop **********/
      {
        if(bomb1y == guny)
        {
          bomb1 = 0;
          gotoxy(bomb1x,bomb1y);
          puts(" ");
        if(((bomb1x >= gunx) &&(bomb1x < (gunx + 3))) && (gunstatus))
          {
            lives--;
            gunstatus = 0;
            guncount = 60;
            gunexplodes(0);
            gotoxy(gunx,guny);
            if(gunx == 18)
              printf("  ");
            else printf("   ");           
            if(!lives)
            {
              gotoxy(11,0);
              printf("Lives: %d", lives);
              gameover(0);
              goto RESTART;
            }
            
              
          }       
        }
        bomb1y++;
        if(bomb1y < guny)
        {
          gotoxy(bomb1x,bomb1y);
          puts("*");
        }
        if(bomb1y > 1)
        {
          gotoxy(bomb1x,bomb1y-1);
          puts(" ");
        }
      }
        
      
    fastloop++;
    }                                                        /* End of Fast Loop  */
    
/********************* UFO CONTROL AREA **********************/
    if(ufo1 == 0)      /*  Starts the UFO */
    {
      switch (rndseed)
      { 
        case 64 : ufo1 = 1;      /* Moves it Right to Left */
                        ufo1x = 20;
                        ufo1y = 3;
                        ufo1d = -1;
                        break;
        case 32 : ufo1 = 1;    /*  Moves it Left to Right */
                        ufo1x = -1;
                        ufo1y = 3;
                        ufo1d =  1;
                        break;
      }
    }
    if(ufo1 == 1)  /*  Moves the UFO accross the screen */
    { 
      /*                   This section drops bombs       */
      if(((rndseed > 80) && (rndseed <= 127) && (!bomb1)) || ((ufo1x == gunx) && (!bomb1)))
      {
        bomb1 = 1;  
        bomb1x = ufo1x;
        bomb1y = ufo1y;
        /* The next 2 lines try to prevent being killed by off-screen bombs */
        /* Haven't figured out why it happens, this is just a patch */
        if(bomb1x < 1 )
          bomb1x = 1; /* leaves a single columb border */
        if(bomb1x > 18)
          bomb1x = 18; /* leaves a single columb border */
        
      }
      
      ufo1x = ufo1x + ufo1d;
       
      switch (ufo1x)
      {
        
        case -1 :  gotoxy(0, ufo1y) ;      /* UFO dissapears off left side */
                       puts(" ");
                       ufo1 = 0;
                       break;
        
        case 0  :  gotoxy(ufo1x, ufo1y) ;
                       puts("   ");
                       gotoxy(ufo1x, ufo1y) ;
                       puts("-");
                       break;
                     
        case 1  :  gotoxy(ufo1x, ufo1y) ;
                       puts("    ");
                       gotoxy(ufo1x, ufo1y) ;
                       puts("o-");
                       break;
     
        case 18 :  gotoxy(ufo1x-(ufo1d + ufo1d), ufo1y);
                        puts("  ");
                        gotoxy(ufo1x, ufo1y);
                        puts("-o");
                        break;
                   
        case 19 :  gotoxy(ufo1x-(ufo1d + ufo1d), ufo1y);
                        puts("  ");
                        gotoxy(ufo1x, ufo1y);
                        puts("-");
                        break;
        
        case 20 :  ufo1 = 0;               /*  UFO dissapears off right side */
                        gotoxy(ufo1x-(ufo1d + ufo1d), ufo1y);
                        puts("  ");
                        break;
   
        default  :  gotoxy(ufo1x-(ufo1d + ufo1d), ufo1y);
                       puts("   ");
                       gotoxy(ufo1x, ufo1y);
                       puts("-o-");
                       break;
       }
     
     }
    
/***************  Joypad Control Area  ***********************/
    if(!gunstatus)
    {
      guncount--;
      if(!guncount)
        {
          gunstatus = 1;
          gunx = 9;
          gotoxy(gunx,guny);
          puts("=^=");
        }
      goto SKIPJOYPAD;
    }
    key=joypad();                 /* puts the returned value from joypad() into key */
   
   

    if(key & J_RIGHT)             /******* RIGHT ********/
    {                             
      rndseed++;
      if(gunx < 18)
      {
        gotoxy(gunx, guny);
        printf("   ");
        gunx = gunx + 1;
        gotoxy(gunx, guny);
        printf("=^=");
      } 
      if(gunx > 17)
      {
        gotoxy(gunx, guny);
        printf("   ");
        gotoxy(gunx, guny);
        printf("=^");
      } 
    
 /* gotoxy(gunx, guny);
    printf("=^");
 */
    }

  if(key & J_LEFT)             /***********LEFT************/
  {
    rndseed++;
    gotoxy(gunx, guny);
    printf("   ");
    if(gunx > -1)
    {
      gunx = gunx - 1;
    }
    gotoxy(gunx, guny);
    printf("=^=");
    
 }

  if(key & J_UP)               /*********** UP*********** */
  {
    /* 
    puts("You pressed Up !     ");
   */
  }

  if(key & J_DOWN)              /**********DOWN**************/
  {
    /*
    puts("You pressed Down !   ");
    */
  }
  
  if(key & J_A)                   /********* A BUTTON: FIRE ************/
  {
    if((shot1 == 0) & (fireenable == 1))
    {
      gunshoots(0);
      shot1 = 1;              /*  Launch Missile  */
      shot1x = gunx + 1;
      shot1y = guny - 1;
      fireenable = 0;
    }
  }
  if(!(key & J_A))
    fireenable = 1;
  if(key & J_B)                /********* B BUTTON ************/
  {
    /* puts("You pressed B");  */
  } 

SKIPJOYPAD:
  if(key & J_START)
  {
    /* puts("You pressed Start");  */
  }

  if(key & J_SELECT)
  {
    /*  puts("You pressed Select");   */
  }
    
    

 }                              /* end of loop */


}                               /* end main */


